
int transdte_handle;
string transdte_lang;
string transdte_string;
string transdte_path;

int dte_tag=('d'<<24)|('t'<<16)|('e'<<8);


// read choices

void transdte_readchoices(void)
{
 if(tagexists(0,dte_tag,0))
 {
  tagreads(0,dte_tag,transdte_lang);
 }
 else
 {
  transdte_lang="{TRANSDTE_02}";
  translate(transdte_lang);
 }
}


// write choices

void transdte_writechoices(void)
{
 tagwrites(0,dte_tag,transdte_lang);
}


// read language data from file

void transdte_readdata()
{
 int h;
 string s;

 transdte_string="";
 h = fileopen(transdte_path + "\\Language\\"+transdte_lang+".txt", "rb");
 if (!h)
 {
  s = "{TRANSDTE_03}";
  translate(s);
  errorbox(transdte_lang+s);
 }
 else
  while(!fileeof(h))
  {
   filereadtext(s, h);
   transdte_string += s;
   transdte_string += "\n";
  }
 fileclose(h);
}


// search for string t in string s, and set t to converted string

int transdte_find(string s, string &t)
{
 int p, b, e;

 if((p = s / t) >= 0)
 {
  b = p + slen(t);
  for(e = b; mids(s, e, 1) != "\n" && e != slen(s); ++e);
  t = mids(s, b, e - b);
 }
 return p;
}


// deal with 'TransDate' menu entry

int transdte_entry(int entry, int subcode)
{
 int i = 0, n;
 string c, s, f, d = "";

 if(subcode >= 0)
  return(0);

 gettimeformat(f, s);
 
 while(i < slen(f))
 {
  c = mids(f, i++, 1);
  if (c != "%")
   d += c;
  else
  {
   n = mids(f, i, 1) == "Z" ? 3 : 2;
   c = mids(f, i, n);
   i += n;

   if(c == "WE" || c == "W3")
   {
    gettimestring("%ZWN", s);
    s = c + s + "/";
    transdte_find(transdte_string, s);
   }
   else
    if(c == "MO" || c == "M3")
    {
     gettimestring("%ZMN", s);
     s = c + s + "/";
     transdte_find(transdte_string, s);
    }
   else
    if(c == "ST")
    {
     gettimestring("%ZDY", s);
     s = c + s + "/";
     transdte_find(transdte_string, s);
    }
   else
    gettimestring("%" + c, s);

   d += s;
  }
 }
 type(d);
 return(0);
}


// shade or un-shade 'TransDate' menu entry

int transdte_flags(int entry, string &text)
{
 return((activetype(TEXTFRAME) > 1)?0:SHADED);
}


// deal with 'Language' menu entries

int transdte_langentry(int entry,int subcode)
{
 if(entry==0)
 {
  transdte_entry(0,-1);
 }
 else
 {
  transdte_lang=string_menu(transdte_handle,entry);
  transdte_readdata();
  transdte_writechoices();
 }
 return(0);
}


// tick 'Language' menu entry

int transdte_langflags(int entry, string &text)
{
 if(entry==0) return(DOTTED);

 if(text==transdte_lang)
  return(TICKED);
 return(0);
}


// build menu of languages

int transdte_menu(int open)
{
 string s;

 if(transdte_handle)
 {
  delete_menu(transdte_handle);
  transdte_handle=create_menu("{TRANSDTE_00}");
 }

 addentry_menu(transdte_handle,"transdte_langentry","transdte_langflags","","A_D","{TRANSDTE_04}");

 startscan();
 while(nextobject(transdte_path + "\\Language", "*.txt", s))
 {
  s=s>>4;
  addentry_menu(transdte_handle,"transdte_langentry","transdte_langflags","","", s);
 }
 return(transdte_handle);
}


// create 'TransDate' menu and add it to 'Applets' menu

void main(void)
{
 script_menu_initialise();

 appletpath(transdte_path);
 transdte_path+="\\TransDate";

 transdte_handle=create_menu("{TRANSDTE_00}");
 script_menu_insert("transdte_entry","transdte_flags","transdte_menu","","{TRANSDTE_01}");
 transdte_readchoices();
 transdte_readdata();
 transdte_menu(1); // ensure key press is recognised
}
